#!/usr/bin/env python3
# -*- coding: utf-8 -*-

"""This algorithm is based on a
`machine-learned <https://gitlab.wikimedia.org/mnz/section-alignment>`_ model
that classifies (read *aligns*) equivalent section titles across Wikipedia language editions.

Given a target section title, it looks up images available in all analogous sections and suggests them.

High-level steps:

- gather aligned section titles from the model's output
- extract existing section images from all Wikipedias through a wikitext parser
- combine the above data to generate suggestions

The first step is actually implemented in :mod:`imagerec.article_images`,
while the second and the third in :mod:`imagerec.recommendation`.
The following functions essentially package section alignment's output into the final format.
"""

from pyspark.sql import DataFrame, SparkSession
from pyspark.sql import functions as F

from image_suggestions import shared


def read_parquet(
    spark: SparkSession, section_alignment_suggestions_parquet: str
) -> DataFrame:  # pragma: no cover
    """Load image suggestions based on section alignment
    as output by :mod:`imagerec.recommendation`.

    :param spark: an active Spark session
    :param section_alignment_suggestions_parquet: a HDFS path to a
      parquet generated by :mod:`imagerec.recommendation`
    :return: the dataframe of:

        - item_id (string) - page Wikidata QID
        - target_id (bigint) - page ID
        - target_title (string) - page title, in original case and underscored
        - target_index (int) - section numerical index, starts from 1
        - target_heading (string) - page section, in URL anchor format.
          More details in :func:`section_topics.pipeline.wikitext_headings_to_anchors`
        - recommended_images (array<map<string,array<string>>>): image suggestions
          as output by :mod:`imagerec.recommendation` (see example row)
        - target_wiki_db (string) - wiki project
    """
    return spark.read.parquet(section_alignment_suggestions_parquet)


def get_section_alignment_suggestions_with_page_data(
    spark: SparkSession,
    weekly_snapshot: str,
    section_alignment_suggestions_parquet: str,
) -> DataFrame:  # pragma: no cover
    """Add page revision and IDs to :mod:`imagerec.recommendation`'s output.

    :param spark: an active Spark session
    :param weekly_snapshot: a ``YYYY-MM-DD`` date
    :param section_alignment_suggestions_parquet: a HDFS path to a
      parquet generated by :mod:`imagerec.recommendation`
    :return: the dataframe of:

        - item_id (string) - page Wikidata QID
        - target_page_rev_id (bigint): page revision ID
        - target_page_id (bigint) - page ID
        - target_page_title (string) - page title, in original case and underscored
        - target_index (int) - section numerical index, starts from 1
        - target_heading (string) - page section, in URL anchor format.
          More details in :func:`section_topics.pipeline.wikitext_headings_to_anchors`
        - recommended_images (array<map<string,array<string>>>): image suggestions
          as output by :mod:`imagerec.recommendation` (see example row)
        - target_wiki_db (string) - wiki project
    """
    section_alignment_suggestions = read_parquet(
        spark, section_alignment_suggestions_parquet
    )

    monthly_snapshot = shared.get_monthly_snapshot(weekly_snapshot)
    main_pages = shared.load_non_commons_main_pages(spark, monthly_snapshot)
    revisions = shared.load_latest_revisions(spark, monthly_snapshot)

    return (
        section_alignment_suggestions.join(
            main_pages,
            on=[
                section_alignment_suggestions.target_id == main_pages.page_id,
                section_alignment_suggestions.target_wiki_db == main_pages.wiki_db,
            ],
            how='inner',
        )
        .join(revisions, on=['wiki_db', 'page_id'], how='inner')
        .select(
            'item_id',
            revisions.rev_id.alias('target_page_rev_id'),
            main_pages.page_id.alias('target_page_id'),
            section_alignment_suggestions.target_title.alias('target_page_title'),
            'target_index',
            'target_heading',
            'recommended_images',
            'target_wiki_db',
        )
    )


def get_expanded_section_alignment_suggestions(
    spark: SparkSession,
    weekly_snapshot: str,
    section_alignment_suggestions_parquet: str,
) -> DataFrame:  # pragma: no cover
    """Explode :mod:`imagerec.recommendation`'s output as an intermediate step to
    assemble the final dataset.

    :param spark: an active Spark session
    :param weekly_snapshot: a ``YYYY-MM-DD`` date
    :param section_alignment_suggestions_parquet: a HDFS path to a
      parquet generated by :mod:`imagerec.recommendation`
    :return: the dataframe of:

        - wiki_db (string) - wiki project
        - target_page_rev_id (bigint): page revision ID
        - target_page_id (bigint) - page ID
        - target_page_title (string) - page title, in original case and underscored
        - target_section_index (int) - section numerical index, starts from 1
        - target_section_heading (string) - page section, in URL anchor format.
          More details in :func:`section_topics.pipeline.wikitext_headings_to_anchors`
        - item_id (string) - page Wikidata QID
        - suggested_image (string) - Commons page title, in original case and underscored
        - origin_wiki (string) - wiki where the suggestion comes from
    """
    section_alignment_suggestions = get_section_alignment_suggestions_with_page_data(
        spark, weekly_snapshot, section_alignment_suggestions_parquet
    )

    return (
        section_alignment_suggestions.select(
            '*', F.explode('recommended_images').alias('ris_array')
        )
        .select(
            '*', F.explode('ris_array').alias('origin_wiki', 'recommended_image_list')
        )
        .select('*', F.explode('recommended_image_list').alias('recommended_image'))
        .select(
            F.col('target_wiki_db').alias('wiki_db'),
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            F.col('target_index').alias('target_section_index'),
            F.col('target_heading').alias('target_section_heading'),
            'item_id',
            F.translate('recommended_image', ' ', '_').alias('suggested_image'),
            'origin_wiki',
        )
        .orderBy(
            'item_id', 'target_page_title', 'target_section_index', 'recommended_image'
        )
    )


def get(
    spark: SparkSession,
    weekly_snapshot: str,
    section_alignment_suggestions_parquet: str,
) -> DataFrame:
    """Gather image suggestions based on section alignment.

    :param spark: an active Spark session
    :param weekly_snapshot: a ``YYYY-MM-DD`` date
    :param section_alignment_suggestions_parquet: a HDFS path to a
      parquet generated by :mod:`imagerec.recommendation`
    :return: the dataframe of:

        - wiki_db (string) - wiki project
        - target_page_rev_id (bigint): page revision ID
        - target_page_id (bigint) - page ID
        - target_page_title (string) - page title, in original case and underscored
        - target_section_index (int) - section numerical index, starts from 1
        - target_section_heading (string) - page section, in URL anchor format.
          More details in :func:`section_topics.pipeline.wikitext_headings_to_anchors`
        - suggested_image (string) - Commons page title, in original case and underscored
        - target_qid (string) - page Wikidata QID
        - kind (string) - ``istype-section-alignment``
        - origin_wikis (array<string>) - wikis where the suggestion comes from
        - confidence (int) - suggestion confidence score
    """
    suggestions = get_expanded_section_alignment_suggestions(
        spark, weekly_snapshot, section_alignment_suggestions_parquet
    )
    monthly_snapshot = shared.get_monthly_snapshot(weekly_snapshot)
    commons_images = shared.load_commons_images(spark, monthly_snapshot)

    return (
        suggestions
        # Join with Commons data to eliminate non-Commons files
        .join(
            commons_images,
            on=[suggestions.suggested_image == commons_images.page_title],
            how='inner',
        )
        .groupBy(
            'wiki_db',
            'item_id',
            'target_page_id',
            'target_page_rev_id',
            'target_page_title',
            'target_section_index',
            'target_section_heading',
            'suggested_image',
        )
        .agg(F.array_distinct(F.collect_list('origin_wiki')).alias('origin_wikis'))
        .orderBy(
            'target_page_title', 'target_section_index', 'suggested_image', 'item_id'
        )
        .select(
            'wiki_db',
            'target_page_rev_id',
            'target_page_id',
            'target_page_title',
            'target_section_index',
            'target_section_heading',
            'suggested_image',
            suggestions.item_id.alias('target_qid'),
            F.lit('istype-section-alignment').alias('kind'),
            'origin_wikis',
            # TODO: arbitrary confidence score, needs fixing
            F.lit(80).alias('confidence'),
        )
    )
